export class DatUtils {

    static getNumWeekFromDate(d: Date) {
        const oneJan =
            new Date(d.getFullYear(), 0, 1);

        const numberOfDays =
            Math.floor((d.getTime() - oneJan.getTime()) / (24 * 60 * 60 * 1000));

        return Math.ceil((d.getDay() + 1 + numberOfDays) / 7);
    }

    static getDateFromNumber(dateToConvert: number): Date {
        const year = dateToConvert.toString().substring(0, 4);
        const month = dateToConvert.toString().substring(4, 6);
        const day = dateToConvert.toString().substring(6, 8);
        return new Date(+year, +month - 1, +day);
    }

    static getNumberFromDate(date: Date): number {
        if (!date) {
            return null;
        }

        const year = date.getFullYear();
        const month = date.getMonth() + 1;
        const day = date.getDate();

        const jourEnStr = Number(year.toString() + this.lPad0N(month, 2) + this.lPad0N(day, 2));

        return jourEnStr;
    }

    static lPad0N(num: number, size: number): string {
        let s = num + '';
        while (s.length < size) {
            s = '0' + s;
        }
        return s;
    }
}