import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppComponent } from './app.component';
import { SchedulerComponent } from './scheduler/scheduler.component';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { SchedulerAppService } from './schedulerApp.service';
import { MatDialogModule } from '@angular/material/dialog';
import { UpdateEventDialogComponent } from './scheduler/update-event-dialog/update-event-dialog.component';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { SchedulerOverviewComponent } from './scheduler/update-event-dialog/scheduler-overview.component';

@NgModule({
  declarations: [
    AppComponent,
    SchedulerComponent,
    UpdateEventDialogComponent,
    SchedulerOverviewComponent
  ],
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    MatButtonModule,
    MatButtonToggleModule,
    MatDialogModule
  ],
  providers: [
    SchedulerAppService],
  exports: [
    MatButtonModule,
    MatButtonToggleModule,
    MatDialogModule
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
