import { Injectable, NgZone } from '@angular/core';
import type { SchedulerEnterprise, SchedulerStatic } from 'dhtmlx-scheduler-ultimate';
import { BehaviorSubject } from 'rxjs';

// eslint-disable-next-line no-var
declare var Scheduler: SchedulerEnterprise;

@Injectable()
export class SchedulerAppService {
  // the main scheduler
  schedulerInstanceMain: SchedulerStatic | undefined = undefined;
  // the scheduler in the update modal
  schedulerInstanceUpdateModal: SchedulerStatic | undefined = undefined;

  public resize$: BehaviorSubject<boolean> = new BehaviorSubject<boolean>(false);

  get SchedulerInstanceMain() {
    this._ngZone.runOutsideAngular(() => {
      if (!this.schedulerInstanceMain) {
        this.schedulerInstanceMain = Scheduler.getSchedulerInstance();

        this.disableMarkNowTimer(this.schedulerInstanceMain);
      }

      this.schedulerInstanceMain.clearAll();
    });
    return this.schedulerInstanceMain;
  }

  get SchedulerInstanceUpdateModal() {
    this._ngZone.runOutsideAngular(() => {
      if (!this.schedulerInstanceUpdateModal) {
        this.schedulerInstanceUpdateModal = Scheduler.getSchedulerInstance();

        this.disableMarkNowTimer(this.schedulerInstanceUpdateModal);
      }

      this.schedulerInstanceUpdateModal.clearAll();
    });
    return this.schedulerInstanceUpdateModal;
  }

  constructor(private _ngZone: NgZone) {
  }

  private disableMarkNowTimer(scheduler: SchedulerStatic) {
    scheduler.attachEvent('onTemplatesReady', function () {
      clearInterval(this._mark_now_timer);
    });
  }

}
